unit UFormCategorySelect;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  UAcronym;

type

  { TFormCategorySelect }

  TFormCategorySelect = class(TForm)
    ButtonOk: TButton;
    ButtonCancel: TButton;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: char);
  private
    { private declarations }
  public
    procedure Load(RemoveItems: TStrings);
  end;

var
  FormCategorySelect: TFormCategorySelect;

resourcestring
  SCategory = 'Category';
  SRemoveCategory = 'Remove categories';
  SRemoveCategoryQuery = 'Do you really want to remove selected categories?';

implementation

{$R *.lfm}

uses
  UCore;

{ TFormCategorySelect }

procedure TFormCategorySelect.FormShow(Sender: TObject);
begin
end;

procedure TFormCategorySelect.FormCreate(Sender: TObject);
begin
  Core.CoolTranslator1.TranslateComponentRecursive(Self);
end;

procedure TFormCategorySelect.ListBox1DblClick(Sender: TObject);
begin
  ButtonOk.Click;
end;

procedure TFormCategorySelect.ListBox1KeyPress(Sender: TObject; var Key: char);
begin
  if Key = #13 then ButtonOk.Click;
end;

procedure TFormCategorySelect.Load(RemoveItems: TStrings);
var
  Index: Integer;
  I: Integer;
begin
  with Core.AcronymDb do begin
    ListBox1.Sorted := False;
    while ListBox1.Items.Count < Categories.Count do
      ListBox1.Items.Add('');
    while ListBox1.Items.Count > Categories.Count do
      ListBox1.Items.Delete(ListBox1.Items.Count - 1);
    for I := 0 to Categories.Count - 1 do begin
      ListBox1.Items.Strings[I] := TAcronymCategory(Categories[I]).Name;
      ListBox1.Items.Objects[I] := Categories[I];
      ListBox1.Selected[I] := False;
    end;
    ListBox1.Sorted := True;
    for I := 0 to RemoveItems.Count - 1 do begin
      Index := ListBox1.Items.IndexOf(RemoveItems[I]);
      if Index <> -1 then ListBox1.Items.Delete(Index);
    end;
  end;
end;

end.

